#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"
#include "twinCATadsLib.h"

extern int waitTWINCATfinished(void);
int twinCATadsInit(void)
{
  int cc = 0;

  if ((cc=cdiRegisterBusFilter("TWINCAT",filterTwinCAT)) != 0 ) goto err;
  if ((cc=cdiRegisterBusInitialization("TWINCAT",initTwinCATcdi)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler("TWINCAT",execTwinCAT)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup("TWINCAT",exitTwinCAT)) != 0 ) goto err;
  if ((cc=cdiRegisterBusScanner("TWINCAT",twinCatScanFcn)) != 0 ) goto err;

err:
  if (cc)
  {
    //cdilog("%s : failure in bus registration TWINCAT",erlst[cc]);
	  /*Temporaly modified*/
	  cdilog("%s : failure in bus registration TWINCAT",cc);
  }
  return cc;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      twinCATadsInit();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      waitTwinCATfinished();
      break;
  }
  return (TRUE);
}
