#ifndef WINCELIB_H_
#define WINCELIB_H_

//#define ctime tctime

int strnicmp(char *s1,char *s2,int n);
int stricmp(char *s1,char *s2);
char *strrev(char *s);
char *strupr(char *s);
char *strlwr(char *s);
char *getenv(const char *envstr);
int perror(const char *errstr);
int __cdecl close(int f);
int __cdecl read( int f, void *buffer, unsigned int count );

int __cdecl write( int f, const void *buffer, unsigned int count );
long __cdecl lseek( int f, long offset, int origin );

/* Time functions declaration */
#ifndef _TM_DEFINED
struct tm {
    int tm_sec;			// seconds
    int tm_min;			// minutes
    int tm_hour;		// hours
    int tm_mday;		// day of the month
    int tm_mon;			// month
    int tm_year;		// years since 1900 (from 0)
    int tm_wday;		// days since Sunday (from 0)
    int tm_yday;		// days since Jan 1
    int tm_isdst;		// daylight savings (summertime) flag
    };
#define _TM_DEFINED
#endif

static union {
	time_t t_val;
	struct time_pack {
		unsigned int ss:6;
		unsigned int mm:6;
		unsigned int dd:5;
		unsigned int hh:6;
		unsigned int mo:4;
		unsigned int yr:10;
		unsigned int wd:3;
	} tm_val;
} _t_cnv;

struct timeb
{
  time_t time;
  unsigned short millitm;
  short timezone;
  short dstflag;
};
size_t strftime(char *s, size_t maxs, const char *f, const struct tm *t);
char *asctime(const struct tm* tmptr);
int ftime(struct timeb *tb);
void tzset(void);
void TmToSystemTime(struct tm * tmbuffer, SYSTEMTIME *st);
void SystemTimeToTm(SYSTEMTIME *st, struct tm * tmbuffer);
void SetTz(SYSTEMTIME *_st);
time_t mktime(struct tm *timeptr);
char *ctime(const time_t *utc);
//used in CDI
int remove(const char *filename); 
int rename ( const char * oldname, const char * newname );

int kbhit(void);
int getch(void);
int putch(int c);

#endif /* WINCELIB_H_ */
